;| Hhen  (1.2.2)
Master s  1.2
(c) Christoph Spiegel
CAD-Spiegel.jimdo.com
CAD-Spiegel@gmx.at
09.10.2009
;
Systemvariabeln:
	cs-hkbl		Blocknamen
	cs-hkat		Attributnamen Hhe
	cs-hkbt		Attributnamen Bezeichnung
	cs-hkla		Layer
	cs-hksk		Skalierung
	cs-hkgn		Genauigkeit
	cs-hkbz		Bezeichung
	cs-hkh+		relative Hhe
	cs-hkh-		Koordinaten Hhe
Systembefehle:
	cs_att		Attribut schreiben/leseen	(cs_att [Objekt] [Attributbezeichung] [Wert])
	cs_rund		Wert runden			(cs_rund [Wert] [Genauigkeit])
	cs_vese		Vergleichsebene setzen		(cs_vese)
	cs_hkse		Hhenkote setzen		(cs_hkse [Punkt])
	cs_hkak		Hhenkote aktulisieren		(cs_hkak)
	cs_hkop		Optionen			(cs_hkop)
|;
;	Standardwerte
(if (not cs-hkbl)
  (setq cs-hkbl "HK") ; Block;  HK
  )
(if (not cs-hkat)
  (setq cs-hkat "KOTHOHE") ; Attribut Hhe:  KOTHOHE
  )
(if (not cs-hkbt)
  (setq cs-hkbt "PREFIX") ; Attribut Prefix:  PREFIX
  )
(if (not cs-hksk)
  (setq cs-hksk "1") ; Skalierung:  1
  )
(if (not cs-hkgn)
  (setq cs-hkgn 2) ; Anzahl der Kommastellen:  2
  )
 ;	Unterfunktion: cs_att
(defun cs_att (obj att wert / attn x)
  (if (= wert "#")
    (progn
      (setq obj (vlax-ename->vla-object obj))
      (if (and
	    (= (vla-get-hasattributes obj) :vlax-true)
	    (safearray-value
	      (setq attn (vlax-variant-value (vla-getattributes obj)))
	      )
	    )
	(foreach x (vlax-safearray->list attn)
	  (if (= (vla-get-tagstring x) att)
	    (setq tex (vla-get-textstring x))
	    )
	  )
	)
      (eval tex)
      )
    (progn
      (vl-load-com)
      (setq obj (vlax-ename->vla-object obj))
      (if (and
	    (= (vla-get-hasattributes obj) :vlax-true)
	    (safearray-value
	      (setq attn (vlax-variant-value (vla-getattributes obj)))
	      )
	    )
	(foreach x (vlax-safearray->list attn)
	  (if (= (vla-get-tagstring x) att)
	    (vla-put-textstring x wert)
	    )
	  )
	)
      )
    )
  )
 ;	Unterfunktion: cs_rund
(defun cs_rund (zahl stellen / str strl falg z)
  (setq	str  (rtos zahl 2 stellen)
	strl 1
  )
  (if (wcmatch str "*#.*")
    (progn
      (setq flag T
	    z 0
      )
      (while flag
	(if (= "." (substr str (setq z (1+ z)) 1))
	  (setq	flag nil
		strl (strlen (substr str z))
	  )
	)
      )
    )
    (setq str (strcat str "."))
  )
  (repeat (abs (- (1- strl) stellen))
    (setq str (strcat str "0"))
  )
  (eval str)
)
 ;		HK		;
(defun C:hk (/ flag pk)
  (setq os (getvar "osmode")
	areq (getvar "attreq")
	adia (getvar "attdia")
	clay (getvar "clayer")
	)
  (if (and cs-hkh+ cs-hkh-)
    (progn
      (setq flag T)
      (while flag
	(initget "Aktualisieren Option Vergleichsebene")
	(setq pk
	       (getpoint
		 "\nHhenkote setzen [Aktualisieren/Option/Vergleichsebene]: "
		 )
	      )
	(cond
	  ((= (type pk) 'LIST)
	   (cs_hkse pk)
	   )
	  ((= pk "Aktualisieren")
	   (setq flag nil)
	   (cs_hkak)
	   )
	  ((= pk "Option")
	   (setq flag nil)
	   (cs_hkop)
	   )
	  ((= pk "Vergleichsebene")
	   (cs_vese)
	   )
	  (T (setq flag nil))
	  )
	)
      )
    (progn
      (princ "\n* Keine Vergleichsebene gewhlt!")
      (cs_vese)
      )
    )
  )
 ;	VESE
(defun cs_vese (/ flag pk obj adia clay)
  (initget "Whlen")
  (setq pk (getpoint "\n Vergleichsebene setzen [Whlen]: "))
  (if (= pk "Whlen")
    (progn
      (setq flag T)
      (while
	(= cs-hkbl
	   (cdr
	     (assoc
	       2
	       (entget
		 (setq obj (car (entsel "\n Vergleichsebene whlen: ")))
		 )
	       )
	     )
	   )
	 (setq flag    nil
	       cs-hkh- (cddr (assoc 10 (entget obj)))
	       cs-hkh+ (atof (cs_att (car obj) cs-veat "#"))
	       )
	 )
      )
    (progn
      (setq cs-hkh+ (getreal "\nHhe der Vergleichsebene: ")
	    h	    (cs_rund cs-hkh+ 2)
	    cs-hkh- (cadr pk)
	    adia    (getvar "ATTDIA")
	    clay    (getvar "CLAYER")
	    )
      (if (zerop (atof h))
	(setq h (strcat (chr 177) h))
	(if (not (minusp (atof h)))
	  (setq h (strcat "+" h))
	  )
	)
      (if cs-hkla
	(setvar "CLAYER" cs-hkla)
	)
      (setvar "ATTDIA" 0)
 ; Block einfgen
      (command "_insert" cs-hkbl pk cs-hksk cs-hksk 0 "" "")
 ; Attribut bearbeiten
      (cs_att (entlast) cs-hkat h)
 ; Wert zurcksetzen
      (setvar "ATTDIA" adia)
      (setvar "CLAYER" clay)
      )
    )
  )
 ;	HKSE
(defun cs_hkse (pk / hkh adia clay)
  (setq	hkh  (cs_rund (+ cs-hkh+ (- (cadr pk) cs-hkh-)) cs-hkgn)
	clay (getvar "CLAYER")
	)
  (if (not (minusp (atof hkh)))
    (if	(zerop (atof hkh))
      (setq hkh (strcat (chr 177) hkh))
      (setq hkh (strcat "+" hkh))
      )
    )
  (if cs-hkla
    (setvar "CLAYER" cs-hkla)
    )
  (setvar "osmode" 0)
  (setvar "attreq" 0)
  (command "_insert" cs-hkbl pk cs-hksk cs-hksk 0)
  (cs_att (entlast) cs-hkat hkh)
  (if (and cs-hkbt cs-hkbz)
    (cs_att (entlast) cs_hkbt cs_hkbz)
    )
  (setvar "CLAYER" clay)
  (setvar "osmode" os)
  (setvar "attreq" areq)
  )
 ;	HKAK
(defun cs_hkak (/ ss z obj hkh)
  (princ "\n Hhenkote whlen: ")
  (setq	ss (ssget '((0 . "INSERT")))
	z  -1
	)
  (repeat (sslength ss)
    (setq obj (ssname ss (setq z (1+ z)))
	  hkh (cs_rund
		(+ cs-hkh+ (- (caddr (assoc 10 (entget obj))) cs-hkh-))
		cs-hkgn
		)
	  )
    (if	(not (minusp (atof hkh)))
      (if (zerop (atof hkh))
	(setq hkh (strcat (chr 177) hkh))
	(setq hkh (strcat "+" hkh))
	)
      )
    (cs_att obj cs-hkat hkh)
    (if	(and cs-hkbt cs-hkbz)
      (cs_att obj cs-hkbt cs-hkbz)
      )
    )
  )
 ;	HKOP
(defun cs_hkop (/ ant)
  (initget "Block Layer Skalierung beZeichnung Genauigkeit")
  (setq	ant
	 (getkword
	   "\n Option whlen [Block/Layer/Skalierung/beZeichnung/Genauigkeit"
	   )
	)
  (cond
    ((= ant "Block")
     (setq cs-hkbl
	    (getstring "\n Blocknamen eingeben [# fr Auswhlen]: ")
	   )
     (if (= cs-hkbl "#")
       (cdr
	 (assoc	2
		(entget (car (entsel "\n  Block whlen: ")))
		)
	 )
       )
     (setq cs-hkat (getstring "\n Attributnamen fr Hhen eingeben: "))
     (setq cs-hkbt
	    (getstring "\n Attributnamen fr Bezeichnung eingeben: ")
	   )
     )
    ((= ant "Layer")
     (setq cs-hkla
	    (getstring "\n Layernamen eingeben [# fr Auswhlen]: ")
	   )
     (if (= cs-hkla "#")
       (setq cs-hkla
	      (cdr
		(assoc 8
		       (entget (car (entsel "\n  Objekt whlen: ")))
		       )
		)
	     )
       )
     (if (= cs-hkla "")
       (setq cs-hkla nil)
       )
     )
    ((= ant "Skalierung")
     (setq cs-hksk (getreal "\n  Faktor eingeben: "))
     )
    ((= ant "Genauigkeit")
     (setq cs-hkgn (getint "\n Anzahl der Kommastellen eingeben: "))
     )
    ((= ant "beZeichnung")
     (setq cs-hkbz (getstring "\n Bezeichnung eingeben: "))
     (if (= cs-hkbt "")
       (setq cs-hkbt nil)
       )
     )
    )
  )